#include<bits/stdc++.h>
using namespace std;
int main(){
	int n,q;
	cin>>n>>q;
	long long a[n];
	for(int i=0;i<n;i++){
		cin>>a[i];
	}
	while(q--){
		int x;
		cin>>x;
		for(int i=0;i<n;i++){
			a[i]+=x;
		}
		long long g=0;
		for(int i=0;i<n;i++){
			g=__gcd(a[i],g);
		}
		cout<<g<<"\n";
	}
}